import java.io.*;
import java.util.Date;

public class BankAccountDemo
{
    private BankAccount myAccount;

    public BankAccountDemo()
    {
        myAccount = new BankAccount();
    }

    public void run()
    {
        initializeBankAccount();
        testBankAccount();
    }

    protected void initializeBankAccount()
    {
        Date d = new Date (99, 02, 23);
        addTransaction( new Deposit   ( d, 200 ) );
        addTransaction( new Deposit   ( d, 100 ) );
        addTransaction( new Withdrawal( d, 50  ) );
        addTransaction( new Deposit   ( d, 100 ) );
        addTransaction( new Withdrawal( d, 50  ) );
    }

    protected void testBankAccount()
    {
        int currentBalance = myAccount.balance();
        System.out.println( "Balance = $" + currentBalance/100 +
                            "."           + currentBalance%100 );

        System.out.println();
        System.out.println( "AUDIT TRAIL" );
        myAccount.print();
    }

    protected void addTransaction( Transaction t )
    {
        myAccount.add( t );
    }
}
