import java.io.*;
import java.util.Date;
import java.util.Vector;

public class FilterBankAccountDemo
{
   private FilterBankAccount myAccount;

   public static void main( String [] args ) throws IOException
   {
      FilterBankAccountDemo application = new FilterBankAccountDemo();
      application.run();
   }

   public FilterBankAccountDemo()
   {
      myAccount = new FilterBankAccount();
   }

   public void run()
   {
      initializeBankAccount();
      testBankAccount();
      testFiltering();
   }

   protected void initializeBankAccount()
   {
      Date d = new Date (99, 02, 23);
      addTransaction( new Deposit( d, 2000000 )   );
      addTransaction( new Deposit( d, 1000000 )   );
      addTransaction( new Withdrawal( d, 5000000 ) );
      addTransaction( new Deposit( d, 1500000 )   );
      addTransaction( new Withdrawal( d, 5000 ) );
   }

   protected void testBankAccount()
   {
      myAccount.print();
   }

   protected void addTransaction( Transaction t )
   {
      myAccount.add( t );
   }

   protected void testFiltering()
   {
      System.out.println( "Suspicious transactions:" );
      System.out.println( "------------------------" );

      Vector suspiciousTransactions =
          myAccount.largeTransactions( 1000000 );
      for (int i = 0; i < suspiciousTransactions.size(); i++)
      {
          Transaction t = (Transaction) suspiciousTransactions.elementAt( i );
          t.print();
          System.out.println();
      }
   }
}
